/**
 おかしな振る舞いの整数
 */

public class FunnyInt implements Calcable{
	private int v=0;
	
	public FunnyInt(int x){
		v=x;
	}

	/** 名前に反して引き算結果を返す */
	public Calcable add(Calcable b){
		int y=Integer.parseInt(b.value());
		return new FunnyInt(v-y);
	}

	/** 名前に反して足し算結果を返す */
	public Calcable sub(Calcable b){
		int y=Integer.parseInt(b.value());
		return new FunnyInt(v+y);
	}

	public String value(){
		return new Integer(v).toString();
	}

	/** 面倒なのでテストコードを封入 */
	public static void main(String[] args){
		Calcable c=new FunnyInt(10);
		Calcable d=new FunnyInt(7);

		Calcable e=c.add(d);
		System.out.println(e.value()); // 17のはず・・・？
	}
}
